#define MODE_HOVERING 0
#define MODE_HOLDING  1
#define MODE_DRAGGING 2

#define MOUSE_LEFT 1
#define MOUSE_RIGHT 2
#define MOUSE_MIDDLE 4

client
	var
		cursor_x = 1
		cursor_y = 1
		cursor_pos
		cursor_ang
		mouse_state
		mouse_mode = MODE_HOVERING

		atom/mouse_over
		atom/mouse_drag
		atom/mouse_drag_location
	proc
		UpdateCursorPos()
			if(cursor_pos)
				var/semi = findtext(cursor_pos,":"), comma = findtext(cursor_pos,",")
				var/cx = (text2num(cursor_pos)-1)*TILE_WIDTH+text2num(copytext(cursor_pos,semi+1,comma))
				var/cy = copytext(cursor_pos,comma+1); semi = findtext(cy,":"); cy = (text2num(cy)-1)*TILE_HEIGHT + text2num(copytext(cy,semi+1))
				cursor_x = cx
				cursor_y = cy
				cursor_pos = null

		UpdateCursorAng()
			UpdateCursorPos()
			cursor_ang = atan2(cursor_x-bound_width/2,cursor_y-bound_height/2)

	Click(atom/object,location,control,params)
		mob.onClick(object,location,control,params)

	DblClick(atom/object,location,control,params)
		mob.onDblClick(object,location,control,params)

	MouseDown(atom/object,location,control,params)
		mouse_mode = 1
		mouse_drag = object
		mouse_drag_location = location
		var/list/l = params2list(params)
		cursor_pos = l["screen-loc"]
		mouse_state |= (l["left"]=="1" ? MOUSE_LEFT : 0) + (l["right"]=="1" ? MOUSE_RIGHT : 0) + (l["middle"]=="1" ? MOUSE_MIDDLE : 0)
		mob.onMouseDown(object,location,control,params)

	MouseUp(atom/object,location,control,params)
		var/list/l = params2list(params)
		cursor_pos = l["screen-loc"]
		mouse_state &= ~((l["left"]=="1" ? MOUSE_LEFT : 0) + (l["right"]=="1" ? MOUSE_RIGHT : 0) + (l["middle"]=="1" ? MOUSE_MIDDLE : 0))
		mob.onMouseUp(object,location,control,params)
		spawn(0)
			mouse_mode = MODE_HOVERING
			mouse_drag = null
			mouse_drag_location = null

	MouseEntered(atom/object,location,control,params)
		mouse_over = object
		mob.onMouseEntered(object,location,control,params)

	MouseExited(atom/object,location,control,params)
		mouse_over = null
		mob.onMouseExited(object,location,control,params)

	MouseMove(atom/object,location,control,params)
		var/list/l = params2list(params)
		cursor_pos = l["screen-loc"]
		mouse_over = object
		mob.onMouseMove(object,location,control,params)

	MouseDrag(atom/object,atom/over_object,src_location,over_location,src_control,over_control,params)
		var/list/l = params2list(params)
		cursor_pos = l["screen-loc"]
		mouse_over = over_object
		mob.onMouseDrag(object,over_object,src_location,over_location,src_control,over_control,params)
		if(mouse_mode==MODE_HOLDING)
			mouse_mode = MODE_DRAGGING

	MouseDrop(atom/object,atom/over_object,src_location,over_location,src_control,over_control,params)
		var/list/l = params2list(params)
		cursor_pos = l["screen-loc"]
		mouse_over = over_object
		mob.onMouseDrop(object,over_object,src_location,over_location,src_control,over_control,params)

	MouseWheel(atom/object,delta_x,delta_y,location,control,params)
		mob.onMouseWheel(object,delta_x,delta_y,location,control,params)

mob
	proc
		onClick(atom/object,location,control,params)
			object.Click(location,control,params)

		onDblClick(atom/object,location,control,params)
			object.DblClick(location,control,params)

		onMouseDown(atom/object,location,control,params)
			object.MouseDown(location,control,params)

		onMouseUp(atom/object,location,control,params)
			if(object) object.MouseUp(location,control,params)

		onMouseEntered(atom/object,location,control,params)
			object.MouseEntered(location,control,params)

		onMouseExited(atom/object,location,control,params)
			object.MouseExited(location,control,params)

		onMouseMove(atom/object,location,control,params)
			object.MouseMove(location,control,params)

		onMouseDrag(atom/object,atom/over_object,src_location,over_location,src_control,over_control,params)
			object.MouseDrag(over_object,src_location,over_location,src_control,over_control,params)
			if(over_object) over_object.MouseDragged(object,over_location,src_location,over_control,src_control,params)

		onMouseDrop(atom/object,atom/over_object,src_location,over_location,src_control,over_control,params)
			object.MouseDrop(over_object,src_location,over_location,src_control,over_control,params)
			if(over_object) over_object.MouseDropped(object,over_location,src_location,over_control,src_control,params)

		onMouseWheel(atom/object,delta_x,delta_y,location,control,params)
			object.MouseWheel(delta_x,delta_y,location,control,params)

atom
	proc
		MouseDragged(atom/object,atom/src_location,atom/over_location,src_control,over_control,params)

		MouseDropped(atom/object,atom/src_location,atom/over_location,src_control,over_control,params)